# -*- coding: utf-8 -*-
from __future__ import absolute_import
import logging


def ini_log(filename="/data/logs/aa.log"):
  logging.basicConfig(level=logging.ERROR,
    format='%(asctime)s  %(filename)s : LINE %(lineno)-4d %(levelname)s  %(message)s',
    datefmt='%Y-%m-%d %A %H:%M:%S', filename=filename, filemode='a')
  console = logging.StreamHandler()
  console.setLevel(logging.info)  # 屏幕显示的级别
  formatter = logging.Formatter('%(filename)s : LINE %(lineno)-4d  %(levelname)s  %(message)s')
  console.setFormatter(formatter)
  logging.getLogger().addHandler(console)

def define_logger(filename="/data/logs/aa.log",debug=True):
    logger = logging.getLogger("")
    if debug==True:
        logger.setLevel(logging.INFO)
    else:
        logger.setLevel(logging.ERROR)

    # 设置输出格式
    formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

    # 设置日志文件处理器
    fh = logging.FileHandler(filename)
    fh.setFormatter(formatter)    # 为这个处理器添加格式

    # 设置屏幕stdout输出处理器
    formatter_stdout = logging.Formatter('%(name)s - %(levelname)s - %(message)s')
    sh  = logging.StreamHandler(stream=None)
    sh.setFormatter(formatter_stdout)

    # 把处理器加到logger上
    logger.addHandler(fh)
#    logger.addHandler(sh)
